	#include <avr/pgmspace.h> 
	#include "tiny2313.h"
	#include "macros.h"


//    .    
	#define NOKIA_SCK	B, 4, H	//	( 2  / SCLK)
	#define NOKIA_DOUT	B, 3, H	//	( 3  / SDIN)
	#define NOKIA_D_C	B, 2, H	//	( 4  )
	#define NOKIA_RESET	B, 0, H	//	( 8  )

//   :
// 1 - VDD(3.3)
// 5 - CS (  )
// 6 - GND
// 7 - VOUT (     1...4,7 ))

//  
	#define F_CPU			(8000000)

//    
	#define GLCD_PIXELX			(84)
	#define GLCD_PIXELY			(48)

//   (normal Functionset)
	#define GLCD_FUNCTIONSET	(0x20)	// 0b00100000 Function set
	#define GLCD_SETXADDR		(0x80)	// 0b10000000 Set X address of RAM
	#define GLCD_SETYADDR		(0x40)	// 0b01000000 Set Y address of RAM
	#define	GLCD_DISPLAYBLANK	(0x08)	// 0b00001000 display blank
	#define	GLCD_DISPLAYFLUSH	(0x09)	// 0b00001001 all display segments on
	#define	GLCD_DISPLAYNORMAL	(0x0C)	// 0b00001100 normal mode
	#define	GLCD_DISPLAYINVERT	(0x0D)	// 0b00001101 inverse video mode

//   (extended Functionset)
	#define GLCD_FUNCTIONSETEXT	(0x21)	// 0b00100001  
	#define GLCD_SET_BIAS		(0x10)	// 0b00010000 
	#define GLCD_SET_VOP		(0x80)	// 0b10000000 write VOP to register
	#define GLCD_TEMPCOEF		(0x06)	// 0b00000110 TF = 2

//	#define GLCD_BIAS_1_100		(0x00)	// 0b00000000 1:100
//	#define GLCD_BIAS_1_80		(0x01)	// 0b00000001 1:80
//	#define GLCD_BIAS_1_65		(0x02)	// 0b00000010 1:65
	#define GLCD_BIAS_1_48		(0x03)	// 0b00000011 1:48
//	#define GLCD_BIAS_1_40		(0x04)	// 0b00000100 1:40/1:34
//	#define GLCD_BIAS_1_24		(0x05)	// 0b00000101 1:24
//	#define GLCD_BIAS_1_18		(0x06)	// 0b00000110 1:18/1:16
//	#define GLCD_BIAS_1_10		(0x07)	// 0b00000111 1:10/1:9/1:8


//  
void nokia_init(void)
{
	//   
	on(NOKIA_SCK);
	on(NOKIA_RESET);
	direct(NOKIA_SCK, O);
	direct(NOKIA_RESET, O);
	direct(NOKIA_DOUT, O);
	direct(NOKIA_D_C, O);

	//  
	off(NOKIA_RESET);
	asm volatile ("nop"); asm volatile ("nop");
	asm volatile ("nop"); asm volatile ("nop");
	on(NOKIA_RESET);

	//    
	nokia_cmd(GLCD_FUNCTIONSETEXT);
	//   
	nokia_cmd(GLCD_TEMPCOEF);
	//    1:48
	nokia_cmd(GLCD_SET_BIAS | GLCD_BIAS_1_48);
	//  (    )
	nokia_set_contrast(120);
	//  .
	nokia_set_inverse(FALSE);
}

